
#include <WinSAPI.h>

#include "test.h"
#include "top.h"


u16* GenerateIcon()
{
	u16* icon = new u16[1024];

	// Now we do the hijack!
	// -------
	
	dmaCopy(test, Screen.GetBackScreen(), 256*192*2);
	Screen.Show();

	dmaCopy(top, upScreen.GetBackScreen(), 256*192*2);
	upScreen.Show();
	
	while(1)
	{
		scanKeys();
		if(keysHeld())
			break;
	}	
	
	// And generate the icon
	// -------
	
	srand(IPC->curtime[7]);
	for(int y=0;y!=32;y++)
	{
		for(int x=0;x!=32;x++)
		{
			icon[y*32+x]=RGB2INT((int) 32*rand()/(RAND_MAX+1), x, y);
		}
	}

	return icon;
}

class ColorDemo : public WinSApp
{
    public:
 
    ColorDemo():
            WinSApp("Color Demo", GenerateIcon()){}
    
        void Launch() const;
};

void ColorDemo::Launch() const
{
	int thirdcolor=0;
	u16 *backbuffer, *upbackbuffer;
	backbuffer = Screen.GetBackScreen();
	upbackbuffer = upScreen.GetBackScreen();
	
	touchPosition touch;
	
	while( 1 )
	{
		scanKeys();
 
		touch=touchReadXY();
		if(!(IPC->buttons & 1<<6))
			thirdcolor=(touch.px+touch.py)>>4;
		else if(keysHeld())
			break;


		for(int y=0;y!=192;y++)
		{
			for(int x=0;x!=256;x++)
			{
				backbuffer[y*256+x]=RGB2INT(thirdcolor, x>>3, y>>3);
			}
		}
		for(int y=0;y!=192;y++)
		{
			for(int x=0;x!=256;x++)
			{
				upbackbuffer[(256*191-y*256)+x]=RGB2INT(thirdcolor, x>>3, y>>3);
			}
		}
		upScreen.Printf(20, 20, RGB2INT(0, 0, 0), "Color demo for WinDS, by SausageBoy");
		upScreen.Printf(20, 40, RGB2INT(0, 0, 0), "Press any key to quit");

		upScreen.Printf(20, 80, RGB2INT(0, 0, 0), "Touching is good");

		
		Screen.Show();
		upScreen.Show();
	}
}

const ColorDemo demo;
 
void InstallApps()
{
    demo.Install();
}

