/*+----------------------------------------------+
  | Cippotto: WinDS Chip8 Emulator               |
  | (c) Francesco Lombardi 2006                  |
  +----------------------------------------------+
    Created for WinDS 2006 Compo
    http://www.gbawins.com
    http://itaprogaming.free.fr
  +----------------------------------------------+*/

#include <winsapi.h>
#include "chip8wdsApp.h"

extern "C"
{
  #include "CHIP8.h"
}

chip8wds_Class *Chip8Emu = NULL;

void chip8wds_ApplicationClass::Launch() const
{
  if (Chip8Emu == NULL) 
  {
    Chip8Emu = new chip8wds_Class;
    gWinS.AddSubControl(Chip8Emu);
  } else 
  {
    gWinS.AddSubControl(new CtlMessageBox("Info", "Another instance of Cippotto is already running.") );
  } 
}

/****************************************************************************/
/* Turn sound on                                                            */
/****************************************************************************/
extern "C" void chip8_sound_on (void)
{
  // Here I should implement a sort of 'beep!!'
}

/****************************************************************************/
/* Turn sound off                                                           */
/****************************************************************************/
extern "C" void chip8_sound_off (void)
{
  // Here I can stop the previously called 'beep!!'
}


extern "C" void chip8_interrupt (void)
{
  Chip8Emu->interrupt();
}

const chip8wds_ApplicationClass chip8wds_Object("Cippotto");
