/*
  --- !!! WARNING !!! ---
  This file comes directly from ndslib. I have only changed variable names in
  order to avoid linking conflicts with other applibs.
*/
/*+----------------------------------------------+
  | Cippotto: WinDS Chip8 Emulator               |
  | (c) Francesco Lombardi 2006                  |
  +----------------------------------------------+
    Created for WinDS 2006 Compo
    http://www.gbawins.com
    http://itaprogaming.free.fr
  +----------------------------------------------+*/

//---------------------------------------------------------------------------------
#ifndef	_key_h_
#define	_key_h_
//---------------------------------------------------------------------------------

#define KEYPAD_TOUCH (1<<12)
#define KEYPAD_X (1<<10)
#define KEYPAD_Y (1<<11)
#define KEYS           (*(volatile unsigned short int*)0x04000130)

#ifdef __cplusplus
extern "C" {
#endif
void c8ScanKeyPad();
void c8KeyPadInit();
unsigned int c8KeysPressed();
unsigned int c8KeysDown();
unsigned int c8KeysUp();
const char * c8GetKeyName(int value);
#ifdef __cplusplus
}
#endif
#define KEYPAD_CUR ( ((~KEYS)&0x3ff) | (((~IPC->buttons)&3)<<10) | (((~IPC->buttons)<<6) & KEYPAD_TOUCH ))

//---------------------------------------------------------------------------------
#endif // _keys_h_
//---------------------------------------------------------------------------------
