#include <winsapi.h>

/* Our Corner Button Control class */
class CtlButtonCn : public Control
{
    private:
        bool pressed;
        
    public:
        StringEx seData[9];     // The text of each corner
        int xborder, yborder;
        
        enum corner     // Pointless. :P
        {
            topleft,    top,    topright,
            left,       center, right,
            bottomleft, bottom, bottomright
        };
        
        CtlButtonCn(const Bbox &b);     // Constructor
        void HandleMessages();          // Message Handler
        
        void setText(enum corner cn, StringEx se);  // Set the text of a corner via a string
        void setText(int cn, StringEx se);          // Set the text of a corner via a string
        void setTexts(StringEx se[]);               // Set the text of all the corners via an array of strings
        void setTexts(const char cd[]);             // Set the text of all the corners via an array of characters
        
        StringEx getText(enum corner cn = center);  // Get the text of a corner
        StringEx getText(int cn);                   // Get the text of a corner
        
        void setFont(enum corner cn, Font &fn);     // Set the font of a corner
        void setFont(int cn, Font &fn);             // Set the font of a corner
        void setFonts(Font &fn);                    // Set the font of all the corners
        
    protected:
        void _DrawForeground();     // Render the front of the button
};

/* EOF */
