#include <winsapi.h>

#ifndef __CONSOLE_WINDOW_H__
#define __CONSOLE_WINDOW_H__

#define CONWIN_XR   (128)       /* Width  of the message window */
#define CONWIN_YR   (96)        /* Height of the message window */
#define CONWIN_X    (CONWIN_XR + 4)
#define CONWIN_Y    (CONWIN_YR + 14 + 4)

class CtlTextBoxEx : public Control
{
    public:
        string text;

        CtlTextBoxEx(Bbox b);
        void HandleMessages();
        
        void _DrawForeground();
};

/* Our Control class */
class CtlConsoleWindow : public CtlWindow
{
    private:
        CtlTextBoxEx *textBox;
        
    public:
        u16 foregroundColor;
        
        CtlConsoleWindow(Bbox b = Bbox(16, 16, CONWIN_X, CONWIN_Y));
        void HandleMessages();
        
        void write(string s);
        void del(int num);
        
        CtlTextBoxEx *getTextBox();
};

#endif /* ! __CONSOLE_WINDOW_H__ */

/* EOF */
